diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/src/ipc_frontend.c olsrd-current/src/ipc_frontend.c
--- olsrd-0.5.0/src/ipc_frontend.c	2006-01-07 09:16:20.000000000 +0100
+++ olsrd-current/src/ipc_frontend.c	2007-04-28 22:45:06.000000000 +0200
@@ -36,7 +36,7 @@
  * to the project. For more information see the website or contact
  * the copyright holders.
  *
- * $Id: ipc_frontend.c,v 1.28 2006/01/07 08:16:20 kattemat Exp $
+ * $Id: ipc_frontend.c,v 1.31 2007/04/28 20:45:06 bernd67 Exp $
  */
 
 /*
@@ -65,6 +65,16 @@
 #define MSG_NOSIGNAL 0
 #endif
 
+static int ipc_sock = -1;
+static int ipc_conn = -1;
+
+static int
+ipc_send_all_routes(int fd);
+
+static int
+ipc_send_net_info(int fd);
+
+
 /**
  *Create the socket to use for IPC to the
  *GUI front-end
@@ -72,7 +82,7 @@
  *@return the socket FD
  */
 int
-ipc_init()
+ipc_init(void)
 {
   //int flags;
   struct   sockaddr_in sin;
@@ -104,14 +114,14 @@
   if(bind(ipc_sock, (struct sockaddr *) &sin, sizeof(sin)) == -1) 
     {
       perror("IPC bind");
-      OLSR_PRINTF(1, "Will retry in 10 seconds...\n")
+      OLSR_PRINTF(1, "Will retry in 10 seconds...\n");
       sleep(10);
       if(bind(ipc_sock, (struct sockaddr *) &sin, sizeof(sin)) == -1) 
 	{
 	  perror("IPC bind");
 	  olsr_exit("IPC bind", EXIT_FAILURE);
 	}
-      OLSR_PRINTF(1, "OK\n")
+      OLSR_PRINTF(1, "OK\n");
     }
 
   /* show that we are willing to listen */
@@ -138,27 +148,27 @@
 
   addrlen = sizeof (struct sockaddr_in);
   
-  if ((ipc_connection = accept(ipc_sock, (struct sockaddr *)  &pin, &addrlen)) == -1)
+  if ((ipc_conn = accept(fd, (struct sockaddr *)  &pin, &addrlen)) == -1)
     {
       perror("IPC accept");
       olsr_exit("IPC accept", EXIT_FAILURE);
     }
   else
     {
-      OLSR_PRINTF(1, "Front end connected\n")
+      OLSR_PRINTF(1, "Front end connected\n");
       addr = inet_ntoa(pin.sin_addr);
       if(ipc_check_allowed_ip((union olsr_ip_addr *)&pin.sin_addr.s_addr))
 	{
 	  ipc_active = OLSR_TRUE;
-	  ipc_send_net_info();
-	  ipc_send_all_routes();
-	  OLSR_PRINTF(1, "Connection from %s\n",addr)
+	  ipc_send_net_info(ipc_conn);
+	  ipc_send_all_routes(ipc_conn);
+	  OLSR_PRINTF(1, "Connection from %s\n",addr);
 	}
       else
 	{
-	  OLSR_PRINTF(1, "Front end-connection from foregin host(%s) not allowed!\n", addr)
+	  OLSR_PRINTF(1, "Front end-connection from foregin host(%s) not allowed!\n", addr);
 	  olsr_syslog(OLSR_LOG_ERR, "OLSR: Front end-connection from foregin host(%s) not allowed!\n", addr);
-	  close(ipc_connection);
+	  CLOSE(ipc_conn);
 	}
     }
 
@@ -192,6 +202,7 @@
   return OLSR_FALSE;
 }
 
+#if 0
 /**
  *Read input from the IPC socket. Not in use.
  *
@@ -200,9 +211,8 @@
  *@return 1
  */
 int
-ipc_input(int sock)
+ipc_input(int sock __attribute__((unused)))
 {
-  /*
   union 
   {
     char	buf[MAXPACKETSIZE+1];
@@ -215,10 +225,9 @@
       perror("recv");
       exit(1);
     }
-*/
   return 1;
 }
-
+#endif
 
 /**
  *Sends a olsr packet on the IPC socket.
@@ -228,7 +237,7 @@
  *@return negative on error
  */
 void
-frontend_msgparser(union olsr_message *msg, struct interface *in_if, union olsr_ip_addr *from_addr)
+frontend_msgparser(union olsr_message *msg, struct interface *in_if __attribute__((unused)), union olsr_ip_addr *from_addr __attribute__((unused)))
 {
   int size;
 
@@ -240,16 +249,13 @@
   else
     size = ntohs(msg->v6.olsr_msgsize);
   
-  if (send(ipc_connection, (void *)msg, size, MSG_NOSIGNAL) < 0) 
+  if (send(ipc_conn, (void *)msg, size, MSG_NOSIGNAL) < 0) 
     {
-      OLSR_PRINTF(1, "(OUTPUT)IPC connection lost!\n")
-      close(ipc_connection);
+      OLSR_PRINTF(1, "(OUTPUT)IPC connection lost!\n");
+      CLOSE(ipc_conn);
       //olsr_cnf->open_ipc = 0;
       ipc_active = OLSR_FALSE;
-      return;
     }
-  
-  return;
 }
 
 
@@ -308,10 +314,11 @@
   printf("\n");
   */
   
-  if (send(ipc_connection, tmp, IPC_PACK_SIZE, MSG_NOSIGNAL) < 0) // MSG_NOSIGNAL to avoid sigpipe
+  if (send(ipc_conn, tmp, IPC_PACK_SIZE, MSG_NOSIGNAL) < 0) // MSG_NOSIGNAL to avoid sigpipe
     {
-      OLSR_PRINTF(1, "(RT_ENTRY)IPC connection lost!\n")
-      close(ipc_connection);
+      OLSR_PRINTF(1, "(RT_ENTRY)IPC connection lost!\n");
+      CLOSE(ipc_conn);
+
       //olsr_cnf->open_ipc = 0;
       ipc_active = OLSR_FALSE;
       return -1;
@@ -322,8 +329,8 @@
 
 
 
-int
-ipc_send_all_routes()
+static int
+ipc_send_all_routes(int fd)
 {
   struct rt_entry  *destination;
   struct interface *ifn;
@@ -370,10 +377,10 @@
 
 	  tmp = (char *) &packet;
   
-	  if (send(ipc_connection, tmp, IPC_PACK_SIZE, MSG_NOSIGNAL) < 0) // MSG_NOSIGNAL to avoid sigpipe
+	  if (send(fd, tmp, IPC_PACK_SIZE, MSG_NOSIGNAL) < 0) // MSG_NOSIGNAL to avoid sigpipe
 	    {
-	      OLSR_PRINTF(1, "(RT_ENTRY)IPC connection lost!\n")
-	      close(ipc_connection);
+	      OLSR_PRINTF(1, "(RT_ENTRY)IPC connection lost!\n");
+	      CLOSE(ipc_conn);
 	      //olsr_cnf->open_ipc = 0;
 	      ipc_active = OLSR_FALSE;
 	      return -1;
@@ -415,10 +422,10 @@
 
 	  tmp = (char *) &packet;
   
-	  if (send(ipc_connection, tmp, IPC_PACK_SIZE, MSG_NOSIGNAL) < 0) // MSG_NOSIGNAL to avoid sigpipe
+	  if (send(ipc_conn, tmp, IPC_PACK_SIZE, MSG_NOSIGNAL) < 0) // MSG_NOSIGNAL to avoid sigpipe
 	    {
-	      OLSR_PRINTF(1, "(RT_ENTRY)IPC connection lost!\n")
-	      close(ipc_connection);
+	      OLSR_PRINTF(1, "(RT_ENTRY)IPC connection lost!\n");
+	      CLOSE(ipc_conn);
 	      //olsr_cnf->open_ipc = 0;
 	      ipc_active = OLSR_FALSE;
 	      return -1;
@@ -440,8 +447,8 @@
  *
  *@return negative on error
  */
-int
-ipc_send_net_info()
+static int
+ipc_send_net_info(int fd)
 {
   struct ipc_net_msg *net_msg;
   //int x, i;
@@ -452,7 +459,7 @@
 
   msg = (char *)net_msg;
 
-  OLSR_PRINTF(1, "Sending net-info to front end...\n")
+  OLSR_PRINTF(1, "Sending net-info to front end...\n");
   
   memset(net_msg, 0, sizeof(struct ipc_net_msg));
   
@@ -518,10 +525,10 @@
   */
 
 
-  if (send(ipc_connection, (char *)net_msg, sizeof(struct ipc_net_msg), MSG_NOSIGNAL) < 0) 
+  if (send(fd, (char *)net_msg, sizeof(struct ipc_net_msg), MSG_NOSIGNAL) < 0) 
     {
-      OLSR_PRINTF(1, "(NETINFO)IPC connection lost!\n")
-      close(ipc_connection);
+      OLSR_PRINTF(1, "(NETINFO)IPC connection lost!\n");
+      CLOSE(ipc_conn);
       //olsr_cnf->open_ipc = 0;
       return -1;
     }
@@ -533,11 +540,11 @@
 
 
 int
-shutdown_ipc()
+shutdown_ipc(void)
 {
-  OLSR_PRINTF(1, "Shutting down IPC...\n")
-  close(ipc_sock);
-  close(ipc_connection);
+  OLSR_PRINTF(1, "Shutting down IPC...\n");
+  CLOSE(ipc_sock);
+  CLOSE(ipc_conn);
   
   return 1;
 }
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/src/ipc_frontend.h olsrd-current/src/ipc_frontend.h
--- olsrd-0.5.0/src/ipc_frontend.h	2004-11-21 12:28:56.000000000 +0100
+++ olsrd-current/src/ipc_frontend.h	2007-04-20 15:46:04.000000000 +0200
@@ -36,7 +36,7 @@
  * to the project. For more information see the website or contact
  * the copyright holders.
  *
- * $Id: ipc_frontend.h,v 1.12 2004/11/21 11:28:56 kattemat Exp $
+ * $Id: ipc_frontend.h,v 1.13 2007/04/20 13:46:04 bernd67 Exp $
  */
 
 /*
@@ -98,8 +98,6 @@
 };
 
 
-int ipc_connection;
-int ipc_sock;
 olsr_bool ipc_active;
 
 olsr_bool
@@ -108,9 +106,6 @@
 void
 ipc_accept(int);
 
-int
-ipc_send_all_routes(void);
-
 void
 frontend_msgparser(union olsr_message *, struct interface *, union olsr_ip_addr *);
 
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/src/link_set.c olsrd-current/src/link_set.c
--- olsrd-0.5.0/src/link_set.c	2007-02-10 20:27:32.000000000 +0100
+++ olsrd-current/src/link_set.c	2007-04-26 00:08:09.000000000 +0200
@@ -36,7 +36,7 @@
  * to the project. For more information see the website or contact
  * the copyright holders.
  *
- * $Id: link_set.c,v 1.66 2007/02/10 19:27:32 bernd67 Exp $
+ * $Id: link_set.c,v 1.68 2007/04/25 22:08:09 bernd67 Exp $
  */
 
 
@@ -79,19 +79,19 @@
 
 
 clock_t 
-get_hold_time_neighbor()
+get_hold_time_neighbor(void)
 {
   return hold_time_neighbor;
 }
 
 struct link_entry *
-get_link_set()
+get_link_set(void)
 {
   return link_set;
 }
 
 void
-olsr_init_link_set()
+olsr_init_link_set(void)
 {
 
   /* Timers */
@@ -145,7 +145,7 @@
       if(entry->L_link_pending == 1)
 	{
 #ifdef DEBUG
-	  OLSR_PRINTF(3, "HYST[%s]: Setting to HIDE\n", olsr_ip_to_string(&entry->neighbor_iface_addr))
+	  OLSR_PRINTF(3, "HYST[%s]: Setting to HIDE\n", olsr_ip_to_string(&entry->neighbor_iface_addr));
 #endif
 	  return HIDE_LINK;
 	}
@@ -470,7 +470,7 @@
    */
 
 #ifdef DEBUG
-  OLSR_PRINTF(1, "Adding %s=>%s to link set\n", olsr_ip_to_string(local), olsr_ip_to_string(remote))
+  OLSR_PRINTF(1, "Adding %s=>%s to link set\n", olsr_ip_to_string(local), olsr_ip_to_string(remote));
 #endif
 
   /* a new tuple is created with... */
@@ -561,7 +561,7 @@
     {
       neighbor = olsr_insert_neighbor_table(remote_main);
 #ifdef DEBUG
-      OLSR_PRINTF(3, "ADDING NEW NEIGHBOR ENTRY %s FROM LINK SET\n", olsr_ip_to_string(remote_main))
+      OLSR_PRINTF(3, "ADDING NEW NEIGHBOR ENTRY %s FROM LINK SET\n", olsr_ip_to_string(remote_main));
 #endif
     }
 
@@ -587,12 +587,13 @@
        * We'll go for one that is hopefully long
        * enough in most cases. 10 seconds
        */
+
     /* Erik Tromp - commented out. It is not RFC-compliant. Also, MID aliases
      * that are not explicitly declared by a node will be removed as soon as
      * the olsr_prune_aliases(...) function is called.
      *
-     * OLSR_PRINTF(1, "Adding MID alias main %s ", olsr_ip_to_string(remote_main))
-     * OLSR_PRINTF(1, "-> %s based on HELLO\n\n", olsr_ip_to_string(remote))
+     * OLSR_PRINTF(1, "Adding MID alias main %s ", olsr_ip_to_string(remote_main));
+     * OLSR_PRINTF(1, "-> %s based on HELLO\n\n", olsr_ip_to_string(remote));
      * insert_mid_alias(remote_main, remote, MID_ALIAS_HACK_VTIME);
      */
     }
@@ -819,7 +820,7 @@
  *
  */
 static void
-olsr_time_out_link_set()
+olsr_time_out_link_set(void)
 {
 
   struct link_entry *tmp_link_set, *last_link_entry;
@@ -896,7 +897,7 @@
  *@return nada
  */
 static void
-olsr_time_out_hysteresis()
+olsr_time_out_hysteresis(void)
 {
   struct link_entry *tmp_link_set;
 
@@ -910,7 +911,7 @@
       if(TIMED_OUT(tmp_link_set->hello_timeout))
 	{
 	  tmp_link_set->L_link_quality = olsr_hyst_calc_instability(tmp_link_set->L_link_quality);
-	  OLSR_PRINTF(1, "HYST[%s] HELLO timeout %0.3f\n", olsr_ip_to_string(&tmp_link_set->neighbor_iface_addr), tmp_link_set->L_link_quality)
+	  OLSR_PRINTF(1, "HYST[%s] HELLO timeout %0.3f\n", olsr_ip_to_string(&tmp_link_set->neighbor_iface_addr), tmp_link_set->L_link_quality);
 	  /* Update hello_timeout - NO SLACK THIS TIME */
 	  tmp_link_set->hello_timeout = GET_TIMESTAMP(tmp_link_set->last_htime*1000);
 	  /* Recalculate status */
@@ -942,17 +943,17 @@
               nowtm->tm_hour,
               nowtm->tm_min,
               nowtm->tm_sec,
-              (int)now.tv_usec/10000)
+              (int)now.tv_usec/10000);
 
   if (olsr_cnf->ip_version == AF_INET)
   {
-    OLSR_PRINTF(1, "IP address       hyst   LQ     lost   total  NLQ    ETX\n")
+    OLSR_PRINTF(1, "IP address       hyst   LQ     lost   total  NLQ    ETX\n");
     fstr = "%-15s  %5.3f  %5.3f  %-3d    %-3d    %5.3f  %.2f\n";
   }
 
   else
   {
-    OLSR_PRINTF(1, "IP address                               hyst   LQ     lost   total  NLQ    ETX\n")
+    OLSR_PRINTF(1, "IP address                               hyst   LQ     lost   total  NLQ    ETX\n");
     fstr = "%-39s  %5.3f  %5.3f  %-3d    %-3d    %5.3f  %.2f\n";
   }
 
@@ -970,7 +971,7 @@
     OLSR_PRINTF(1, fstr, olsr_ip_to_string(&walker->neighbor_iface_addr),
                 walker->L_link_quality, walker->loss_link_quality,
 		walker->lost_packets, walker->total_packets,
-		walker->neigh_link_quality, etx)
+		walker->neigh_link_quality, etx);
   }
 }
 
@@ -1059,7 +1060,7 @@
       }
 
       else
-        OLSR_PRINTF(3, "Skipping Dijkstra (1)\n")
+        OLSR_PRINTF(3, "Skipping Dijkstra (1)\n");
 
       // create a new ANSN
 
@@ -1138,7 +1139,7 @@
   entry->loss_timeout = GET_TIMESTAMP(entry->loss_hello_int * 1500.0);
 }
 
-static void olsr_time_out_packet_loss()
+static void olsr_time_out_packet_loss(void)
 {
   struct link_entry *walker;
 
@@ -1167,7 +1168,7 @@
     }
 }
 
-void olsr_update_dijkstra_link_qualities()
+void olsr_update_dijkstra_link_qualities(void)
 {
   struct link_entry *walker;
 
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/src/linux/apm.c olsrd-current/src/linux/apm.c
--- olsrd-0.5.0/src/linux/apm.c	2006-11-26 01:32:14.000000000 +0100
+++ olsrd-current/src/linux/apm.c	2007-04-26 00:08:17.000000000 +0200
@@ -36,7 +36,7 @@
  * to the project. For more information see the website or contact
  * the copyright holders.
  *
- * $Id: apm.c,v 1.16 2006/11/26 00:32:14 bernd67 Exp $
+ * $Id: apm.c,v 1.18 2007/04/25 22:08:17 bernd67 Exp $
  */
 
 /*
@@ -128,56 +128,46 @@
   struct olsr_apm_info ainfo;
 
   method = -1;
-  OLSR_PRINTF(3, "Initializing APM\n")
+  OLSR_PRINTF(3, "Initializing APM\n");
 
   if(((fd_index = acpi_probe()) >= 0) && apm_read_acpi(&ainfo))
     method = USE_ACPI;
   else if(apm_read_apm(&ainfo))
     method = USE_APM;
   
-  if(method)
+  if(method != -1)
     apm_printinfo(&ainfo);
 
   return method;
 }
 
+
 void
 apm_printinfo(struct olsr_apm_info *ainfo)
 {
   OLSR_PRINTF(5, "APM info:\n\tAC status %d\n\tBattery percentage %d%%\n\tBattery time left %d mins\n\n",
 	      ainfo->ac_line_status,
 	      ainfo->battery_percentage,
-	      ainfo->battery_time_left)
-
-  return;
+	      ainfo->battery_time_left);
 }
 
 
-
 int
 apm_read(struct olsr_apm_info *ainfo)
 {
-
   switch(method)
     {
     case(USE_APM):
       return apm_read_apm(ainfo);
-      break;
     case(USE_ACPI):
       return apm_read_acpi(ainfo);
-      break;
     default:
-      return 0;
       break;
     }
-
-  return 1;
+  return 0;
 }
 
 
-
-
-
 static int
 apm_read_apm(struct olsr_apm_info *ainfo)
 {
@@ -190,14 +180,14 @@
   if((apm_procfile = fopen(APM_PROC, "r")) == NULL)
     return 0;
 
-  if(fgets(buffer, sizeof(buffer) - 1, apm_procfile) == NULL)
+  if(fgets(buffer, sizeof(buffer), apm_procfile) == NULL)
     {
       fclose(apm_procfile);
       /* Try re-opening the file */
       if((apm_procfile = fopen(APM_PROC, "r")) != NULL)
 	return 0;
 
-      if(fgets(buffer, sizeof(buffer) - 1, apm_procfile) == NULL)
+      if(fgets(buffer, sizeof(buffer), apm_procfile) == NULL)
 	{
 	  /* Giving up */
 	  fprintf(stderr, "OLSRD: Could not read APM info - setting willingness to default");
@@ -205,8 +195,8 @@
 	  return 0;
 	}
     }
+  fclose(apm_procfile);
 
-  buffer[sizeof(buffer) - 1] = '\0';
 
   //printf("READ: %s\n", buffer);
 
@@ -245,18 +235,14 @@
   ainfo->battery_percentage = lainfo.battery_percentage;
   ainfo->battery_time_left = lainfo.battery_time;
   
-  fclose(apm_procfile);
-
   return 1;
 }
 
 
-
 static int
 apm_read_acpi(struct olsr_apm_info *ainfo)
 {
   FILE *fd;
-  char s1[32], s2[32], s3[32], s4[32], inbuff[127];
   int bat_max = 5000; /* Find some sane value */
   int bat_val = 0;
   
@@ -271,22 +257,19 @@
       return 1;
     }
 
-
   /* Get maxvalue */
   if((fd = fopen(acpi_info[fd_index], "r")) == NULL) 
     return 0;
-
-  fgets(inbuff, 127, fd);
-  while(!feof(fd)) 
+  
+  for(;;) 
     {
-      sscanf(inbuff, "%s %s %s %s", s1, s2, s3, s4);
-	
+      char s1[32], s2[32], s3[32], s4[32], inbuff[127];
+      if (fgets(inbuff, sizeof(inbuff), fd) == NULL)
+        break;
+
+      sscanf(inbuff, "%s %s %s %s", s1, s2, s3, s4);	
       if (!strcasecmp(s2, "full")) 
-	{
 	  bat_max = atoi(s4);
-	}
-
-      fgets(inbuff, 127, fd);
     }
   fclose(fd);
 
@@ -295,23 +278,19 @@
     return 0;
 
   /* Extract battery status */
-  fgets(inbuff, 127, fd);
-  while(!feof(fd)) 
+  for(;;)
     {
+      char s1[32], s2[32], s3[32], s4[32], inbuff[127];
+      if (fgets(inbuff, sizeof(inbuff), fd) == NULL)
+        break;
       sscanf(inbuff, "%s %s %s %s", s1, s2, s3, s4);
 
       /* find remaining juice */
       if(!strcasecmp(s1, "Remaining")) 
-	{
 	  bat_val = atoi(s3);
-	}
-
-      fgets(inbuff, 127, fd);
     }
-
   fclose(fd);
 
-
   ainfo->ac_line_status = OLSR_BATTERY_POWERED;
   ainfo->battery_percentage = bat_val * 100 / bat_max;
 
@@ -319,57 +298,56 @@
 }
 
 
-
 static int
 acpi_probe(void)
 {
-  char s1[32], s2[32];
-  FILE *fd;
-  olsr_u16_t i;
+  unsigned int i;
   
-
   /* First check for AC power */
 
   for(i = 0; i < ACPI_AC_CNT; i++)
     {
+      char s1[32], s2[32];
+      int rc;
+      FILE *fd = fopen(acpi_ac[i], "r");
+  
       /* Try opening the info file */
-      if((fd = fopen(acpi_ac[i], "r")) == NULL)
+      if(fd == NULL)
 	continue;
       
       /* Extract info */
-      if(fscanf(fd, "%s %s", s1, s2) < 2)
-	{
-	  fclose(fd);
-	  continue;
-	}
-      
+      rc = fscanf(fd, "%s %s", s1, s2);
+
       /* Close info entry */
       fclose(fd);
 
+      if(rc < 2)
+	  continue;
+      
       /* Running on AC power */
       if(!strcasecmp(s2, "on-line"))
 	return -1;
-
     }
 
-  /* Only checking the first found batery entry... */
+  /* Only checking the first found battery entry... */
   for(i = 0; i < ACPI_BT_CNT; i ++)
     {
-
+      char s1[32], s2[32];
+      int rc;
+      FILE *fd = fopen(acpi_info[i], "r");
+  
       /* Try opening the info file */
-      if((fd = fopen(acpi_info[i], "r")) == NULL)
+      if(fd == NULL)
 	continue;
 
       /* Extract info */
-      if(fscanf(fd, "%s %s", s1, s2) < 2)
-	{
-	  fclose(fd);
-	  continue;
-	}
-
+      rc = fscanf(fd, "%s %s", s1, s2);
       /* Close info entry */
       fclose(fd);
 
+      if(rc < 2)
+	  continue;
+
       /* Check if battery is present */
       if((!strcasecmp(s1, "present:")) && (!strcasecmp(s2, "no"))) 
 	continue;
@@ -379,11 +357,9 @@
 	continue;
 
       fclose(fd);
-
       return i;
     }
 
   /* No battery found */
   return -1;
 }
-
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/src/linux/kernel_routes.c olsrd-current/src/linux/kernel_routes.c
--- olsrd-0.5.0/src/linux/kernel_routes.c	2007-01-31 13:36:50.000000000 +0100
+++ olsrd-current/src/linux/kernel_routes.c	2007-05-17 22:30:09.000000000 +0200
@@ -36,7 +36,7 @@
  * to the project. For more information see the website or contact
  * the copyright holders.
  *
- * $Id: kernel_routes.c,v 1.20 2007/01/31 12:36:50 bernd67 Exp $
+ * $Id: kernel_routes.c,v 1.23 2007/05/17 20:30:09 bernd67 Exp $
  */
 
 
@@ -65,15 +65,14 @@
 {
   struct rtentry kernel_route;
   int tmp;
-  char dst_str[16], mask_str[16], router_str[16];
-
-  inet_ntop(AF_INET, &destination->rt_dst.v4, dst_str, 16);
-  inet_ntop(AF_INET, &destination->rt_mask.v4, mask_str, 16);
-  inet_ntop(AF_INET, &destination->rt_router.v4, router_str, 16);
+  char dst_str[INET_ADDRSTRLEN], mask_str[INET_ADDRSTRLEN], router_str[INET_ADDRSTRLEN];
 
   OLSR_PRINTF(1, "(ioctl)Adding route with metric %d to %s/%s via %s/%s.\n",
-              destination->rt_metric, dst_str, mask_str, router_str,
-              destination->rt_if->int_name)
+              destination->rt_metric,
+              inet_ntop(AF_INET, &destination->rt_dst.v4, dst_str, sizeof(dst_str)),
+              inet_ntop(AF_INET, &destination->rt_mask.v4, mask_str, sizeof(mask_str)),
+              inet_ntop(AF_INET, &destination->rt_router.v4, router_str, sizeof(router_str)),
+              destination->rt_if->int_name);
   
   memset(&kernel_route, 0, sizeof(struct rtentry));
 
@@ -104,14 +103,7 @@
   /*
    * Set interface
    */
-  if((kernel_route.rt_dev = malloc(strlen(destination->rt_if->int_name) + 1)) == 0)
-    {
-      fprintf(stderr, "Out of memory!\n%s\n", strerror(errno));
-      olsr_exit(__func__, EXIT_FAILURE);
-    }
-
-  strcpy(kernel_route.rt_dev, destination->rt_if->int_name);
-
+  kernel_route.rt_dev = destination->rt_if->int_name;
   
   //printf("Inserting route entry on device %s\n\n", kernel_route.rt_dev);
   
@@ -140,13 +132,6 @@
 			       destination->rt_if->int_name); /* Send interface name */
       }
   
-  
-  if (ifnet && kernel_route.rt_dev)
-    {
-      free(kernel_route.rt_dev);
-    }
-  
-  
   return tmp;
 }
 
@@ -170,7 +155,7 @@
 
   OLSR_PRINTF(2, "(ioctl)Adding route: %s(hopc %d)\n", 
 	      olsr_ip_to_string(&destination->rt_dst), 
-	      destination->rt_metric + 1)
+	      destination->rt_metric + 1);
   
 
   memset(&zeroaddr, 0, olsr_cnf->ipsize); /* Use for comparision */
@@ -201,8 +186,8 @@
 
 
   
-  //OLSR_PRINTF(3, "Adding route to %s using gw ", olsr_ip_to_string((union olsr_ip_addr *)&kernel_route.rtmsg_dst))
-  //OLSR_PRINTF(3, "%s\n", olsr_ip_to_string((union olsr_ip_addr *)&kernel_route.rtmsg_gateway))
+  //OLSR_PRINTF(3, "Adding route to %s using gw ", olsr_ip_to_string((union olsr_ip_addr *)&kernel_route.rtmsg_dst));
+  //OLSR_PRINTF(3, "%s\n", olsr_ip_to_string((union olsr_ip_addr *)&kernel_route.rtmsg_gateway));
 
   if((tmp = ioctl(olsr_cnf->ioctl_s, SIOCADDRT, &kernel_route)) >= 0)
     {
@@ -234,14 +219,13 @@
 {
   struct rtentry kernel_route;
   int tmp;
-  char dst_str[16], mask_str[16], router_str[16];
-
-  inet_ntop(AF_INET, &destination->rt_dst.v4, dst_str, 16);
-  inet_ntop(AF_INET, &destination->rt_mask.v4, mask_str, 16);
-  inet_ntop(AF_INET, &destination->rt_router.v4, router_str, 16);
+  char dst_str[INET_ADDRSTRLEN], mask_str[INET_ADDRSTRLEN], router_str[INET_ADDRSTRLEN];
 
   OLSR_PRINTF(1, "(ioctl)Deleting route with metric %d to %s/%s via %s.\n",
-              destination->rt_metric, dst_str, mask_str, router_str)
+              destination->rt_metric,
+              inet_ntop(AF_INET, &destination->rt_dst.v4, dst_str, sizeof(dst_str)),
+              inet_ntop(AF_INET, &destination->rt_mask.v4, mask_str, sizeof(mask_str)),
+              inet_ntop(AF_INET, &destination->rt_router.v4, router_str, sizeof(router_str)));
   
   memset(&kernel_route,0,sizeof(struct rtentry));
 
@@ -309,10 +293,10 @@
 
   OLSR_PRINTF(2, "(ioctl)Deleting route: %s(hopc %d)\n", 
 	      olsr_ip_to_string(&destination->rt_dst), 
-	      destination->rt_metric)
+	      destination->rt_metric);
 
 
-  OLSR_PRINTF(1, "Deleting route: %s\n", olsr_ip_to_string(&tmp_addr))
+  OLSR_PRINTF(1, "Deleting route: %s\n", olsr_ip_to_string(&tmp_addr));
 
   memset(&kernel_route,0,sizeof(struct in6_rtmsg));
 
@@ -346,16 +330,14 @@
 
 
 int
-delete_all_inet_gws()
-{
-  struct rtentry kernel_route;
-  
+delete_all_inet_gws(void)
+{  
   int s;
   char buf[BUFSIZ], *cp, *cplim;
   struct ifconf ifc;
   struct ifreq *ifr;
   
-  OLSR_PRINTF(1, "Internet gateway detected...\nTrying to delete default gateways\n")
+  OLSR_PRINTF(1, "Internet gateway detected...\nTrying to delete default gateways\n");
   
   /* Get a socket */
   if ((s = socket(AF_INET, SOCK_DGRAM, 0)) < 0) 
@@ -375,20 +357,20 @@
     }
 
   ifr = ifc.ifc_req;
-#define size(p) (sizeof (p))
   cplim = buf + ifc.ifc_len; /*skip over if's with big ifr_addr's */
-  for (cp = buf; cp < cplim;cp += sizeof (ifr->ifr_name) + size(ifr->ifr_addr)) 
+  for (cp = buf; cp < cplim; cp += sizeof (ifr->ifr_name) + sizeof(ifr->ifr_addr)) 
     {
+      struct rtentry kernel_route;
       ifr = (struct ifreq *)cp;
       
       
       if(strcmp(ifr->ifr_ifrn.ifrn_name, "lo") == 0)
 	{
-	  OLSR_PRINTF(1, "Skipping loopback...\n")
+          OLSR_PRINTF(1, "Skipping loopback...\n");
 	  continue;
 	}
 
-      OLSR_PRINTF(1, "Trying 0.0.0.0/0 %s...", ifr->ifr_ifrn.ifrn_name)
+      OLSR_PRINTF(1, "Trying 0.0.0.0/0 %s...", ifr->ifr_ifrn.ifrn_name);
       
       
       memset(&kernel_route,0,sizeof(struct rtentry));
@@ -408,29 +390,17 @@
       kernel_route.rt_flags = RTF_UP | RTF_GATEWAY;
 	   
 	   
-      if((kernel_route.rt_dev = malloc(6)) == 0)
-	{
-	  fprintf(stderr, "Out of memory!\n%s\n", strerror(errno));
-	  olsr_exit(__func__, EXIT_FAILURE);
-	}
-	   
-      strncpy(kernel_route.rt_dev, ifr->ifr_ifrn.ifrn_name, 6);
+      kernel_route.rt_dev = ifr->ifr_ifrn.ifrn_name;
 
   
       //printf("Inserting route entry on device %s\n\n", kernel_route.rt_dev);
       
       if((ioctl(s, SIOCDELRT, &kernel_route)) < 0)
-	OLSR_PRINTF(1, "NO\n")
+         OLSR_PRINTF(1, "NO\n");
       else
-	OLSR_PRINTF(1, "YES\n")
-
-
-      free(kernel_route.rt_dev);
-      
-    }
-  
+         OLSR_PRINTF(1, "YES\n");
+    }  
   close(s);
-  
   return 0;
        
 }
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/src/linux/link_layer.c olsrd-current/src/linux/link_layer.c
--- olsrd-0.5.0/src/linux/link_layer.c	2007-02-10 18:11:49.000000000 +0100
+++ olsrd-current/src/linux/link_layer.c	2007-04-26 00:08:17.000000000 +0200
@@ -36,7 +36,7 @@
  * to the project. For more information see the website or contact
  * the copyright holders.
  *
- * $Id: link_layer.c,v 1.12 2007/02/10 17:11:49 bernd67 Exp $
+ * $Id: link_layer.c,v 1.13 2007/04/25 22:08:17 bernd67 Exp $
  */
 
 
@@ -100,7 +100,7 @@
 {
   struct interface *ifd;
 
-  OLSR_PRINTF(1, "Initializing link-layer notification...\n")
+  OLSR_PRINTF(1, "Initializing link-layer notification...\n");
 
 
   for (ifd = ifnet; ifd ; ifd = ifd->int_next) 
@@ -129,7 +129,7 @@
 
   if(ioctl(olsr_cnf->ioctl_s, SIOCSIWSPY, &wrq) < 0)
     {
-      OLSR_PRINTF(1, "Could not clear spylist %s\n", strerror(errno))
+      OLSR_PRINTF(1, "Could not clear spylist %s\n", strerror(errno));
       return -1;
     }
 
@@ -148,7 +148,7 @@
   char	buffer[(sizeof(struct iw_quality) +
 		sizeof(struct sockaddr)) * IW_MAX_SPY];
   
-  OLSR_PRINTF(1, "Adding spynode!\n\n")
+  OLSR_PRINTF(1, "Adding spynode!\n\n");
   
   /* get all addresses already in the driver */
 
@@ -160,7 +160,7 @@
 
   if(ioctl(olsr_cnf->ioctl_s, SIOCGIWSPY, &wrq) < 0)
     {
-      OLSR_PRINTF(1, "Could not get old spylist %s\n", strerror(errno))
+      OLSR_PRINTF(1, "Could not get old spylist %s\n", strerror(errno));
       return 0;
     }
 
@@ -168,7 +168,7 @@
   nbr = wrq.u.data.length;
   memcpy(hw_address, buffer, nbr * sizeof(struct sockaddr));
 
-  OLSR_PRINTF(1, "Old addresses: %d\n\n", nbr)
+  OLSR_PRINTF(1, "Old addresses: %d\n\n", nbr);
 
   /* Check upper limit */
   if(nbr >= IW_MAX_SPY)
@@ -193,7 +193,7 @@
   
   if(ioctl(olsr_cnf->ioctl_s, SIOCSIWSPY, &wrq) < 0)
     {
-      OLSR_PRINTF(1, "Could not clear spylist %s\n", strerror(errno))
+      OLSR_PRINTF(1, "Could not clear spylist %s\n", strerror(errno));
       return 0;
     }
 
@@ -213,7 +213,7 @@
 
   OLSR_PRINTF(1, "\nARP conversion for %s interface %s\n", 
 	      olsr_ip_to_string(ip),
-	      interface)
+	      interface);
 
   tmp_sockaddr.sin_family = AF_INET;
   tmp_sockaddr.sin_port = 0;
@@ -230,7 +230,7 @@
   if((ioctl(olsr_cnf->ioctl_s, SIOCGARP, &arp_query) < 0) ||
      !(arp_query.arp_flags & ATF_COM)) /* ATF_COM - hw addr valid */
     {
-      OLSR_PRINTF(1, "Arp failed: (%s) - trying lookup\n", strerror(errno))
+      OLSR_PRINTF(1, "Arp failed: (%s) - trying lookup\n", strerror(errno));
 
       /* No address - create a thread that sends a PING */
       send_ping(ip);
@@ -238,7 +238,7 @@
       return -1;
     }
 
-  OLSR_PRINTF(1, "Arp success!\n")
+  OLSR_PRINTF(1, "Arp success!\n");
 
   memcpy(mac, &arp_query.arp_ha, sizeof(struct sockaddr));
 
@@ -270,11 +270,11 @@
   dst_in->sin_family = AF_INET;
   memcpy(&dst_in->sin_addr, ip, olsr_cnf->ipsize);
 
-  OLSR_PRINTF(1, "pinging %s\n\n", olsr_ip_to_string(ip))
+  OLSR_PRINTF(1, "pinging %s\n\n", olsr_ip_to_string(ip));
 
   if ((ping_s = socket(AF_INET, SOCK_RAW, PF_INET)) < 0) 
     {
-      OLSR_PRINTF(1, "Could not create RAW socket for ping!\n%s\n", strerror(errno))
+      OLSR_PRINTF(1, "Could not create RAW socket for ping!\n%s\n", strerror(errno));
       return;
     }
 
@@ -292,12 +292,12 @@
   if((sendto(ping_s, packet, MAXIPLEN + MAXICMPLEN + 8, 0, &dst, sizeof(struct sockaddr))) !=
      MAXIPLEN + MAXICMPLEN + 8)
     {
-      OLSR_PRINTF(1, "Error PING: %s\n", strerror(errno))
+      OLSR_PRINTF(1, "Error PING: %s\n", strerror(errno));
     }
 
   /* Nevermind the pong ;-) */
 
-  OLSR_PRINTF(1, "Ping complete...\n")
+  OLSR_PRINTF(1, "Ping complete...\n");
   close(ping_s);
 
   free(packet);
@@ -319,7 +319,7 @@
   int                   has_range = 0;
   struct interface      *iflist;
 
-  //OLSR_PRINTF(1, "Polling link-layer notification...\n")
+  //OLSR_PRINTF(1, "Polling link-layer notification...\n");
 
   for(iflist = ifnet; iflist != NULL; iflist = iflist->int_next)
     {
@@ -337,7 +337,7 @@
       /* Do the request */
       if(ioctl(olsr_cnf->ioctl_s, SIOCGIWSPY, &wrq) < 0)
 	{
-	  OLSR_PRINTF(1, "%-8.16s  Interface doesn't support wireless statistic collection\n\n", iflist->int_name)
+          OLSR_PRINTF(1, "%-8.16s  Interface doesn't support wireless statistic collection\n\n", iflist->int_name);
 	  return;
 	}
       
@@ -358,29 +358,29 @@
 	    continue;
 	  
 	  /* Print stats for each address */
-	  OLSR_PRINTF(1, "MAC")
+	  OLSR_PRINTF(1, "MAC");
 	  for(j = 0; j < 6; j++)
 	    {
-	      OLSR_PRINTF(1, ":%02x", (hwa[i].sa_data[j] % 0xffffff00))
+                    OLSR_PRINTF(1, ":%02x", (hwa[i].sa_data[j] % 0xffffff00));
 	    }
 	  if(!has_range)
 	    OLSR_PRINTF(1, " : Quality:%d  Signal level:%d dBm  Noise level:%d dBm",
 			qual[i].qual,
 			qual[i].level - 0x100, 
-			qual[i].noise - 0x100)
+			qual[i].noise - 0x100);
 	  else
 	    OLSR_PRINTF(1, " : Quality:%d/%d  Signal level:%d dBm  Noise level:%d dBm",
 			qual[i].qual,
 			range.max_qual.qual,
 			qual[i].level - 0x100, 
-			qual[i].noise - 0x100)
+			qual[i].noise - 0x100);
 	  
-	  OLSR_PRINTF(1, "\n")
+	  OLSR_PRINTF(1, "\n");
 	  
 	}
     }
 
-  //OLSR_PRINTF(1, "\n")
+  //OLSR_PRINTF(1, "\n");
   return;
 }
 
@@ -411,7 +411,7 @@
 
   if(ioctl(olsr_cnf->ioctl_s, SIOCGIWRANGE, &wrq) < 0)
     {
-      OLSR_PRINTF(1, "NO RANGE\n")
+      OLSR_PRINTF(1, "NO RANGE\n");
       return -1;
     }
 
